/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;
import javax.persistence.Transient;

import org.apache.commons.lang.StringUtils;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "DET_DIAGRAMA_AUTOBUS_SEQ", sequenceName = "DET_DIAGRAMA_AUTOBUS_SEQ", allocationSize = 1)
@Table(name = "DET_DIAGRAMA_AUTOBUS")
public class DetDiagramaAutobus implements Serializable {

    public final static String WC = "WC";//BAÑO
    public final static String TV = "TV";//TELEVISION
    public final static String PT = "PT";//PORTA TRAJE
    public final static String CF = "CF";//CAFE
    public final static String ME = "ME";//MESA
    public final static String GE = "GE";//GELADEIRA
    public final static String ES = "ES";//ESCADA
    public final static String BR = "BR";//BAR
    
    public final static String ORIENTACION_W = "W";//OESTTE
    public final static String ORIENTACION_S = "S";//SUL
    public final static String ORIENTACION_E = "E";//LESTE
    public final static String ORIENTACION_N = "S";//NORTE
    
    
    
    
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "DET_DIAGRAMA_AUTOBUS_SEQ")
    @Column(name = "DETDIAGRAMAAUTOBUS_ID")
    private Short detdiagramaautobusId;
    @Column(name = "ASIENTO")
    private String asiento;
    @Column(name = "NUMECOLUMNA")
    private Short numecolumna;
    @Column(name = "NUMEFILA")
    private Short numefila;
    @Column(name = "VENDIBLE")
    private Boolean vendible;
    @Column(name = "INTERNET")
    private Boolean internet;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Basic(optional = false)
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "DIAGRAMAAUTOBUS_ID", referencedColumnName = "DIAGRAMAAUTOBUS_ID")
    @ManyToOne
    private DiagramaAutobus diagramaAutobus;
    @Column(name = "ORIENTACION")
    private String orientacion;

    public DetDiagramaAutobus() {
    }

    public Short getDetdiagramaautobusId() {
        return detdiagramaautobusId;
    }

    public void setDetdiagramaautobusId(Short detdiagramaautobusId) {
        this.detdiagramaautobusId = detdiagramaautobusId;
    }

    public String getAsiento() {
        return asiento;
    }

    public void setAsiento(String asiento) {
        this.asiento = asiento;
    }

    public Short getNumecolumna() {
        return numecolumna;
    }

    public void setNumecolumna(Short numecolumna) {
        this.numecolumna = numecolumna;
    }

    public Short getNumefila() {
        return numefila;
    }

    public void setNumefila(Short numefila) {
        this.numefila = numefila;
    }

    public Boolean getVendible() {
        return vendible;
    }

    public void setVendible(Boolean vendible) {
        this.vendible = vendible;
    }

    public Boolean getInternet() {
        return internet;
    }

    public void setInternet(Boolean internet) {
        this.internet = internet;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public DiagramaAutobus getDiagramaAutobus() {
        return diagramaAutobus;
    }

    public void setDiagramaAutobus(DiagramaAutobus diagramaAutobus) {
        this.diagramaAutobus = diagramaAutobus;
    }

    public String getOrientacion() {
		return orientacion;
	}

	public void setOrientacion(String orientacion) {
		this.orientacion = orientacion;
	}

	@Override
    public int hashCode() {
        int hash = 0;
        hash += (detdiagramaautobusId != null ? detdiagramaautobusId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DetDiagramaAutobus)) {
            return false;
        }
        DetDiagramaAutobus other = (DetDiagramaAutobus) object;
        if ((this.detdiagramaautobusId == null && other.detdiagramaautobusId != null) || (this.detdiagramaautobusId != null && !this.detdiagramaautobusId.equals(other.detdiagramaautobusId))) {
            return false;
        }
        return true;
    }

    /**
     * Indica se el tipo del asiento es vendible
     * @param tipoAsiento
     * @return 
     */
    @Transient
    public static boolean asientoVendible(String tipoAsiento){
        if (StringUtils.isEmpty(tipoAsiento)){
            return false;
        }
        
        if (tipoAsiento.equalsIgnoreCase(CF) 
                || tipoAsiento.equalsIgnoreCase(PT) 
                || tipoAsiento.equalsIgnoreCase(TV) 
                || tipoAsiento.equalsIgnoreCase(WC)
                || tipoAsiento.equalsIgnoreCase(GE)
                || tipoAsiento.equalsIgnoreCase(ES)
                || tipoAsiento.contains(BR)) {
            return false;
        }
        
        return true;
    }
    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.DetDiagramaAutobus[detdiagramaautobusId=" + detdiagramaautobusId + "]";
    }
}
